workflow:
  rules:
    - if: $CI_COMMIT_TAG
    - if: $CI_PIPELINE_SOURCE == "pipeline"
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"
    - if: $CI_COMMIT_BRANCH && $CI_OPEN_MERGE_REQUESTS
      when: never
    - if: $CI_COMMIT_BRANCH

format:
  image: mcr.microsoft.com/dotnet/sdk:latest
  script:
    - dotnet tool restore
    - dotnet dotnet-csharpier --check .

publish-docker-image:
  needs: ["format"]
  image: docker:latest
  services:
    - docker:dind
  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
  variables:
    IMAGE_TAG: $CI_REGISTRY_IMAGE:branch-$CI_COMMIT_REF_SLUG
  rules:
    - if: $CI_COMMIT_REF_NAME == $CI_DEFAULT_BRANCH
      variables:
        IMAGE_TAG: $CI_REGISTRY_IMAGE:latest
    - if: $CI_COMMIT_TAG
      variables:
        IMAGE_TAG: $CI_REGISTRY_IMAGE:$CI_COMMIT_TAG
    - if: $PACKAGE_VERSION
      variables:
        IMAGE_TAG: $CI_REGISTRY_IMAGE:latest
        EXTRA_ARGS: --build-arg PACKAGE_VERSION=$PACKAGE_VERSION
    - when: always
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build $EXTRA_ARGS -t $IMAGE_TAG .
    - docker push $IMAGE_TAG
